;################################################################################
;#										#
;# Z80 emulator		 							#
;# copyright (c) 2009-2011 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;create a new page if possible
emu_newpage:	in	ZH,GPIOR2		;write HIGH address
		cpi	ZH,0x40			;check if addr is ROM in speccy
		brcs	emu_newpage_2		;this IS ROM

		push	YH			;save reg
		lds	YH,emu_ram_mpage
		cpi	YH,max_pages-1		;this is the maximum
		brcs	emu_newpage_4		;we can allocate a new page
		ldi	YH,0x50			;border light red (not possible in emulator mode)
		mov	reg_border,YH
		;RED LED !!!!!
		;allow a dummy write to a fixed address
emu_newpage_1:	pop	YH			;restore reg
emu_newpage_2:	ldi	ZL,0xff			;prepare dummy address for write
		ldi	ZH,0x40
		ret

;Z = address in Z80 memory
;YH = last RAM page
emu_newpage_4:	inc	YH			;page pointer + 1
		sts	emu_ram_mpage,YH

		push	ZL			;save lower address byte
		push	XL			;save X-register
		push	XH

		ldi	XH,HIGH(emu_memtab)	;memora table base address
		mov	XL,ZH			;the high address
		st	X,YH			;set new entry
		push	YH			;save upper address byte

		;ZH = ROM address high byte
		clr	ZL			;Z = Flash address


		;YH = RAM addresshigh byte
		mov	XH,YH
		clr	XL			;X is now our RAM addres

		;copy the ROM-page to RAM
emu_newpage_6:	lpm	YH,Z+
		st	X+,YH
		cpi	XL,0
		brne	emu_newpage_6

		pop	ZH			;get upper address byte
		pop	XH			;restore X register
		pop	XL
		pop	ZL			;get lower address byte
		pop	YH			;restore YH register
		ret

