;################################################################################
;#										#
;# Z80 emulator		 							#
;# copyright (c) 2009-2011 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;------------------------------------------------------------------------------
;RST
;------------------------------------------------------------------------------
emu_res:	lds	XL,vsys_keycode
		cpi	XL,0xf5
		brne	emu_res_1
		jmp	emu_start

emu_res_1:	cpi	XL,0xf6
		brne	emu_res_2
		jmp	emu_start_usr

emu_res_2:	cpi	XL,0xf7
		brne	emu_res_3
		jmp	emu_start_sys

emu_res_3:	sbiw	PC_L,1			;discard cmd byte
		jmp	mem_snap_usr

;------------------------------------------------------------------------------
; the level1 jump table for reset
;------------------------------------------------------------------------------

.org (pc+255) & 0xff00

emu_jrtab:	rjmp	emu_res			;code 0x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res

		rjmp	emu_res			;code 1x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 2x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 3x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res

		rjmp	emu_res			;code 4x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 5x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 6x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 7x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 8x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code 9x
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code ax
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code bx
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code cx
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code dx
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code ex
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res


		rjmp	emu_res			;code fx
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res
		rjmp	emu_res

