;################################################################################
;#										#
;# Z80 emulator		 							#
;# copyright (c) 2009-2011 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 3		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro z80_in
		sbrc	@1,0			;keyboard?
		rjmp	PC+11			;no

		ldi	ZH,HIGH(io_fe*2)	;io table
		mov	ZL,@2
		elpm	ZL,Z			;get keytable offset
		ldi	ZH,HIGH(vsys_kbuf)
		ld	@0,Z
		lds	ZL,vsys_sborder		;get spectrum border
		bst	ZL,4
		bld	@0,6
		rjmp	PC+13

		sbrc	@1,5			;kempston joystick
		rjmp	PC+4
		lds	@0,vsys_kinput
		rjmp	PC+8

		sbrc	@1,6			;AVR IO
		rjmp	PC+6
		mov	ZL,@2
		clr	ZL
		ld	@0,Z
		rjmp	PC+2

		mov	@0,const_ff		;empty port
.endm

.macro z80_inbc
		sbrc	reg_c,0			;keyboard?
		rjmp	PC+11			;no

		ldi	ZH,HIGH(io_fe*2)	;io table
		mov	ZL,reg_b
		elpm	ZL,Z			;get keytable offset
		ldi	ZH,HIGH(vsys_kbuf)
		ld	@0,Z
		lds	ZL,vsys_sborder		;get spectrum border
		bst	ZL,4
		bld	@0,6
		rjmp	PC+13

		sbrc	reg_c,5			;kempston joystick
		rjmp	PC+4
		lds	@0,vsys_kinput
		rjmp	PC+8

		sbrc	reg_c,6			;AVR IO
		rjmp	PC+6
		mov	ZL,reg_b
		clr	ZL
		ld	@0,Z
		rjmp	PC+2

		mov	@0,const_ff		;empty port
		mov	ZL,@0
		bst	reg_f,aflag_c		;save carry flag
.if rom_tables == 0
		ldi	ZH,HIGH(emu_flags_log)
		ld	reg_f,Z
.else
		ldi	ZH,HIGH(emu_flagtab_l*2)
		elpm	reg_f,Z
.endif
		bld	reg_f,aflag_c		;restore carry pflag
		z80_clrnflag			;clear N flag
.endm



.macro z80_out
		sbrc	@1,0			;keyboard?
		rjmp	PC+20			;no

		sts	vsys_sborder,@0
		sbrc	@0,4
		sbi	PIND,7
		sbrs	@0,4
		cbi	PIND,7
		push	r16
		mov	r16,@0
		swap	r16
		lsl	r16
		andi	r16,0xe0
		mov	reg_border,r16
		pop	r16
		rjmp	PC+6

		sbrc	@1,6			;AVR IO
		rjmp	PC+4
		mov	ZL,@2
		clr	ZH
		st	Z,@0
.endm

.macro z80_intvec
		ldi	XL,0xff			;default int vector byte
.endm
