
intro:		ldi	XL,0x00
		mov	reg_border,XL
		sei
		ldi	XL,0x05			;cyan on black
		sts	vsys_color,XL
		rcall	sys_clear		;clear screen

		rcall	intro_logo

		ldi	XL,0x05			;cyan on black
		sts	vsys_color,XL

		ldi	XL,0
		ldi	XH,10
		ldi	ZL,LOW(intro_text*2)
		ldi	ZH,HIGH(intro_text*2)
		rcall	sys_textxy

		ldi	XL,0x05
		sts	vsys_color,XL

		ldi	XL,0x28
		sts	vsys_color,XL
		ldi	XL,9
		ldi	XH,12
		rcall	sys_gotoxy
		ldi	ZL,35
		ldi	ZH,0x3e
		ldi	XL,12
intro_fname_1:	elpm	r19,Z+
		cpi	r19,0x20
		sbrs	r19,7
		brcc	intro_fname_2
		ldi	r19,0x20
intro_fname_2:	call	sys_char
		dec	XL
		brne	intro_fname_1

		ldi	XL,0x06
		sts	vsys_color,XL

		ldi	XL,2
		ldi	XH,22
		rcall	sys_gotoxy

testloop_1:	call	fsys_init

		lds	XL,fsys_status
		sbrs	XL,7
		rjmp	testloop_1a

		ldi	XL,0x04
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,15
		ldi	ZL,LOW(intro_ftext*2)
		ldi	ZH,HIGH(intro_ftext*2)
		rcall	sys_textxy

testloop_1a:	ldi	XL,240
		sts	vsys_wait,XL

testloop_2:	lds	XL,vsys_keycode
		cpi	XL,0x20			;space breaks pause
		brne	testloop_3
		ret

testloop_3:	cpi	XL,'f'
		breq	testloop_4
		cpi	XL,'F'
		breq	testloop_4

		lds	XL,vsys_wait
		cpi	XL,0
		brne	testloop_2
		ret

testloop_4:	lds	XL,fsys_status
		sbrs	XL,7
		rjmp	testloop_2
		jmp	fsys_llist


intro_logo:	ldi	XL,0x07
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,2
		ldi	ZL,LOW(logo_text1*2)
		ldi	ZH,HIGH(logo_text1*2)
		rcall	sys_textxy

		ldi	XL,0x06
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,3
		ldi	ZL,LOW(logo_text2*2)
		ldi	ZH,HIGH(logo_text2*2)
		rcall	sys_textxy

		ldi	XL,0x05
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,4
		ldi	ZL,LOW(logo_text3*2)
		ldi	ZH,HIGH(logo_text3*2)
		rcall	sys_textxy

		ldi	XL,0x04
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,5
		ldi	ZL,LOW(logo_text4*2)
		ldi	ZH,HIGH(logo_text4*2)
		rcall	sys_textxy

		ldi	XL,0x03
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,6
		ldi	ZL,LOW(logo_text5*2)
		ldi	ZH,HIGH(logo_text5*2)
		rcall	sys_textxy

		ldi	XL,0x02
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,7
		ldi	ZL,LOW(logo_text6*2)
		ldi	ZH,HIGH(logo_text6*2)
		rcall	sys_textxy

		ldi	XL,0x01
		sts	vsys_color,XL
		ldi	XL,0
		ldi	XH,8
		ldi	ZL,LOW(logo_text7*2)
		ldi	ZH,HIGH(logo_text7*2)
		rcall	sys_textxy

		ldi	XL,0x07
		sts	vsys_color,XL

		ret

		;   "01234567890123456789012345678901"
logo_text1:	.db "  ###   #   #       ###    ###  ",0,0
logo_text2:	.db " #   #  #   #      #   #  #   # ",0,0
logo_text3:	.db " #   #   # #       #   #     #  ",0,0
logo_text4:	.db " #   #    #   [B]   ###     #   ",0,0
logo_text5:	.db " #####   # #       #   #   #    ",0,0
logo_text6:	.db " #   #  #   #      #   #  #     ",0,0
logo_text7:	.db " #   #  #   #       ###   ##### ",0,0


		;   "01234567890123456789012345678901"
intro_text:	.db "  V0.23 (c) 2013 Joerg Wolfram  ",0x00,0x00
intro_ftext:	.db "    PRESS [F] FOR FILE MENU     ",0,0


;-----------------------------------------------------------------------------------
; clear system screen
;-----------------------------------------------------------------------------------
sys_clear:	push	XL
		push	YL
		push	YH
		movw	YL,const_0
sys_vclear_1:	st	Y+,const_0
		cpi	YH,0x19
		brne	sys_vclear_1
		lds	XL,vsys_color
sys_vclear_2:	st	Y+,XL
		cpi	YH,0x1c
		brne	sys_vclear_2
		sts	vsys_xpos,const_0
		sts	vsys_ypos,const_0
		pop	YH
		pop	YL
		pop	XL
		ret

;-----------------------------------------------------------------------------------
; set write coords
; XL=X   XH=Y
;-----------------------------------------------------------------------------------
sys_gotoxy:	sts	vsys_xpos,XL
		sts	vsys_ypos,XH
		ret

sys_space:	ldi	r19,0x20

		;write char r19
sys_char:	push	XL
		push	XH
		push	YL
		push	YH
		push	ZL
		push	ZH
		ldi	ZL,8
		mul	ZL,r19
		ldi	ZH,0x3c
		mov	ZL,r0
		add	ZH,r1
		movw	YL,const_0		;dfile start
		lds	XL,vsys_ypos
		push	XL
		andi	XL,0x18
		add	YH,XL			;YPOS/8
		pop	XL
		andi	XL,0x07
		swap	XL
		lsl	XL
		add	YL,XL
		lds	XL,vsys_xpos
		andi	XL,0x1f
		add	YL,XL
		ldi	XH,8
sys_char_1:	lpm	XL,Z+
		st	Y,XL
		inc	YH
		dec	XH
		brne	sys_char_1

		lds	XH,vsys_ypos
		ldi	XL,32
		mul	XL,XH
		movw	YL,r0
		lds	XL,vsys_xpos
		add	YL,XL
		ldi	XL,0x19
		add	YH,XL
		lds	ZL,vsys_color
		st	Y,ZL

		lds	XL,vsys_xpos
		lds	XH,vsys_ypos
		inc	XL
		cpi	XL,32
		brcs	sys_char_2
		clr	XL
		inc	XH
sys_char_2:	cpi	XH,24
		brcs	sys_char_3
		clr	XH
sys_char_3:	sts	vsys_xpos,XL
		sts	vsys_ypos,XH
		pop	ZH
		pop	ZL
		pop	YH
		pop	YL
		pop	XH
		pop	XL
		ret


		;write zero terminated string from flash to screen
sys_textxy:	rcall	sys_gotoxy
sys_text:	elpm	r19,Z+
		cpi	r19,0x00
		breq	sys_ftext_1
		rcall	sys_char		;write to screen
		rjmp	sys_text
sys_ftext_1:	ret


sys_hexout:	push	r16
		push	r19
		mov	r19,r16
		swap	r19
		andi	r19,0x0f
		subi	r19,0xd0
		cpi	r19,0x3a
		brcs	sys_hexout_1
		subi	r19,0xf9
sys_hexout_1:	rcall	sys_char
		mov	r19,r16
		andi	r19,0x0f
		subi	r19,0xd0
		cpi	r19,0x3a
		brcs	sys_hexout_2
		subi	r19,0xf9
sys_hexout_2:	rcall	sys_char
		pop	r19
		pop	r16
		ret

