#!/usr/bin/perl
#################################################################################
#										#
# circle x-calc table generator							#
# copyright (c) 2010-2011 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 3		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
for($i=0;$i<256;$i++)
{
	$fg=$i & 7;		#fg color
	$bg=($i >> 3) & 7;	#bg color
	$br=($i >> 6) & 1;	#bright
	$fl=($i >> 7) & 1;	#flash

	#first table, flash phase 0
	$value=($bg * 2) + ($fg * 32) + ($br * 16);
	$scell[$i]=$value%256;

	#second table, flash phase 1
	if($fl == 0)
	{
		$value=($bg * 2) + ($fg * 32) + ($br * 16);
	}
	else
	{
		$value=($fg * 2) + ($bg * 32) + ($br * 1);
	}
	$scell[$i+256]=$value%256;

}



###############################################################################
# write table
###############################################################################
open (WTAB, ">atab.inc");
	for($i=0;$i<32;$i++)
	{
		print WTAB "        .db "; 
		for($j=0;$j<8;$j++)
		{
			$cellpos=$i*8+$j;
			$y=$scell[$cellpos];
			#$y=258;
			$low=$y%256;
			$high=($y-$low)/256;
			$high=$y;
	#		if ($low<1) {printf WTAB "0x00"} 
	#		else {printf WTAB "%#2.2x",$low};
	#		print WTAB ",";

			if ($high<1) {printf WTAB "0x00"} 
			else {printf WTAB "%#2.2x",$high};
			if ($j<7) {print WTAB ","}
			else {print WTAB "\n"};
		}
	}

	print WTAB "\n";

	for($i=0;$i<32;$i++)
	{
		print WTAB "        .db "; 
		for($j=0;$j<8;$j++)
		{
			$cellpos=$i*8+$j+256;
			$y=$scell[$cellpos];
			#$y=258;
			$low=$y%256;
			$high=($y-$low)/256;
			$high=$y;
	#		if ($low<1) {printf WTAB "0x00"} 
	#		else {printf WTAB "%#2.2x",$low};
	#		print WTAB ",";

			if ($high<1) {printf WTAB "0x00"} 
			else {printf WTAB "%#2.2x",$high};
			if ($j<7) {print WTAB ","}
			else {print WTAB "\n"};
		}
	}

close(WTAB);

