;################################################################################
;#										#
;# libmio - multi i/o for ATMega644						#
;# keytable - DE layout								#
;# copyright (c) 2007-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;-------------------------------------------------------------------------------
; scancode tables
; f1-fc function keys
; e0=pos1 e1=end e2=left e3=right e4=up e5=down e6=pgup e7=pgdown e8=ins e9=del
; ea=enter eb=tab ec=backspace ed=esc ee=alt+del ef=alt+ins
; c0=power c1=sleep c2=wake c3=num c4=scroll
;-------------------------------------------------------------------------------
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x00, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x01, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x02, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x03, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x04, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x05, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x06, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x07, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x08, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x09, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x0a, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x0b, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x0c, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x0d, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x0e, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x0f, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x10, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x11, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x12, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x13, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x14, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x15, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x16, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x17, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x18, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x19, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x1a, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x1b, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x1c, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x1d, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x1e, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x1f, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfe		;keycode 0x20, space
.db	0xff,0xff,0xff,0xfe,0xff,0xff,0xff,0xfd		;keycode 0x21, shift + 1
.db	0xff,0xff,0xff,0xff,0xff,0xfe,0xff,0xfd		;keycode 0x22, shift + 2
.db	0xff,0xff,0xff,0xfb,0xff,0xff,0xff,0xfd		;keycode 0x23, shift + 3
.db	0xff,0xff,0xff,0xf7,0xff,0xff,0xff,0xfd		;keycode 0x24, shift + 4
.db	0xff,0xff,0xff,0xef,0xff,0xff,0xff,0xfd		;keycode 0x25, shift + 5
.db	0xff,0xff,0xff,0xff,0xef,0xff,0xff,0xfd		;keycode 0x26, shift + 6
.db	0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xfd		;keycode 0x27, shift + 7
.db	0xff,0xff,0xff,0xff,0xfb,0xff,0xff,0xfd		;keycode 0x28, shift + 8
.db	0xff,0xff,0xff,0xff,0xfd,0xff,0xff,0xfd		;keycode 0x29, shift + 9
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xed		;keycode 0x2a, *
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xfd		;keycode 0x2b, +
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf5		;keycode 0x2c, comma
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xfd		;keycode 0x2d, -
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf9		;keycode 0x2e, point
.db	0xef,0xff,0xff,0xff,0xff,0xff,0xff,0xfd		;keycode 0x2f, /

.db	0xff,0xff,0xff,0xff,0xfe,0xff,0xff,0xff		;keycode 0x30, 0
.db	0xff,0xff,0xff,0xfe,0xff,0xff,0xff,0xff		;keycode 0x31, 1
.db	0xff,0xff,0xff,0xfd,0xff,0xff,0xff,0xff		;keycode 0x32, 2
.db	0xff,0xff,0xff,0xfb,0xff,0xff,0xff,0xff		;keycode 0x33, 3
.db	0xff,0xff,0xff,0xf7,0xff,0xff,0xff,0xff		;keycode 0x34, 4
.db	0xff,0xff,0xff,0xef,0xff,0xff,0xff,0xff		;keycode 0x35, 5
.db	0xff,0xff,0xff,0xff,0xef,0xff,0xff,0xff		;keycode 0x36, 6
.db	0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xff		;keycode 0x37, 7
.db	0xff,0xff,0xff,0xff,0xfb,0xff,0xff,0xff		;keycode 0x38, 8
.db	0xff,0xff,0xff,0xff,0xfd,0xff,0xff,0xff		;keycode 0x39, 9
.db	0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xfd		;keycode 0x3a, colon
.db	0xff,0xff,0xff,0xff,0xff,0xfd,0xff,0xfd		;keycode 0x3b, semicolon
.db	0xff,0xff,0xf7,0xff,0xff,0xff,0xff,0xfd		;keycode 0x3c, <
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xfd,0xfd		;keycode 0x3d, =
.db	0xff,0xff,0xef,0xff,0xff,0xff,0xff,0xfd		;keycode 0x3e, >
.db	0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xfd		;keycode 0x3f, ?

.db	0xff,0xff,0xff,0xfd,0xff,0xff,0xff,0xfd		;keycode 0x40, alt+Q
.db	0xfe,0xfe,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x41, shift + a
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xef		;keycode 0x42, shift + b
.db	0xf6,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x43, shift + c
.db	0xfe,0xfb,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x44, shift + d
.db	0xfe,0xff,0xfb,0xff,0xff,0xff,0xff,0xff		;keycode 0x45, shift + e
.db	0xfe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x46, shift + f
.db	0xfe,0xef,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x47, shift + g
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xef,0xff		;keycode 0x48, shift + h
.db	0xfe,0xff,0xff,0xff,0xff,0xfb,0xff,0xff		;keycode 0x49, shift + i
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xf7,0xff		;keycode 0x4a, shift + j
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xfb,0xff		;keycode 0x4b, shift + k
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xfd,0xff		;keycode 0x4c, shift + l
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xfb		;keycode 0x4d, shift + m
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xf7		;keycode 0x4e, shift + n
.db	0xfe,0xff,0xff,0xff,0xff,0xfd,0xff,0xff		;keycode 0x4f, shift + o

.db	0xfe,0xff,0xff,0xff,0xff,0xfe,0xff,0xff		;keycode 0x50, shift + p
.db	0xfe,0xff,0xfe,0xff,0xff,0xff,0xff,0xff		;keycode 0x51, shift + q
.db	0xfe,0xff,0xf7,0xff,0xff,0xff,0xff,0xff		;keycode 0x52, shift + r
.db	0xfe,0xfd,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x53, shift + s
.db	0xfe,0xff,0xef,0xff,0xff,0xff,0xff,0xff		;keycode 0x54, shift + t
.db	0xfe,0xff,0xff,0xff,0xff,0xf7,0xff,0xff		;keycode 0x55, shift + u
.db	0xee,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x56, shift + v
.db	0xfe,0xff,0xfd,0xff,0xff,0xff,0xff,0xff		;keycode 0x57, shift + w
.db	0xfa,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x58, shift + x
.db	0xfc,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x59, shift + z
.db	0xfe,0xff,0xff,0xff,0xff,0xef,0xff,0xff		;keycode 0x5a, shift + y
.db	0xff,0xff,0xff,0xff,0xff,0xef,0xff,0xfd		;keycode 0x5b, 
.db	0xff,0xfb,0xff,0xff,0xff,0xff,0xff,0xfd		;keycode 0x5c, 
.db	0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xfd		;keycode 0x5d, 
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xef,0xfd		;keycode 0x5e, 
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0xfd		;keycode 0x5f, shift+0 (_)

.db	0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xfd		;keycode 0x60, hochkomma
.db	0xff,0xfe,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x61,  a
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xef		;keycode 0x62,  b
.db	0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x63,  c
.db	0xff,0xfb,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x64,  d
.db	0xff,0xff,0xfb,0xff,0xff,0xff,0xff,0xff		;keycode 0x65,  e
.db	0xff,0xf7,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x66,  f
.db	0xff,0xef,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x67,  g
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xef,0xff		;keycode 0x68,  h
.db	0xff,0xff,0xff,0xff,0xff,0xfb,0xff,0xff		;keycode 0x69,  i
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xff		;keycode 0x6a,  j
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xff		;keycode 0x6b,  k
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xfd,0xff		;keycode 0x6c,  l
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfb		;keycode 0x6d,  m
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf7		;keycode 0x6e,  n
.db	0xff,0xff,0xff,0xff,0xff,0xfd,0xff,0xff		;keycode 0x6f,  o

.db	0xff,0xff,0xff,0xff,0xff,0xfe,0xff,0xff		;keycode 0x70,  p
.db	0xff,0xff,0xfe,0xff,0xff,0xff,0xff,0xff		;keycode 0x71,  q
.db	0xff,0xff,0xf7,0xff,0xff,0xff,0xff,0xff		;keycode 0x72,  r
.db	0xff,0xfd,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x73,  s
.db	0xff,0xff,0xef,0xff,0xff,0xff,0xff,0xff		;keycode 0x74,  t
.db	0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xff		;keycode 0x75,  u
.db	0xef,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x76,  v
.db	0xff,0xff,0xfd,0xff,0xff,0xff,0xff,0xff		;keycode 0x77,  w
.db	0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x78,  x
.db	0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x79,  z
.db	0xff,0xff,0xff,0xff,0xff,0xef,0xff,0xff		;keycode 0x7a,  y
.db	0xfd,0xf7,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x7b, 
.db	0xfd,0xfd,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x7c, 
.db	0xfd,0xef,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x7d, 
.db	0xfd,0xfe,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x7e, 
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x7f, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x80, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x81, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x82, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x83, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x84, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x85, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x86, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x87, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x88, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x89, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x8a, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x8b, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x8c, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x8d, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x8e, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x8f, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x90, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x91, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x92, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x93, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x94, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x95, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x96, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x97, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x98, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x99, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x9a, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x9b, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x9c, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x9d, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x9e, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0x9f, no valid key

.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xfe		;keycode 0xa0, shift + space
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa1, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa2, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa3, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa4, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa5, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa6, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa7, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa8, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xa9, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xaa, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xab, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xac, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xad, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xae, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xaf, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb0, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb1, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb2, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb3, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb4, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb5, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb6, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb7, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb8, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xb9, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xba, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xbb, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xbc, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xbd, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xbe, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xbf, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc0, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc1, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc2, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc3, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc4, no valid key
.db	0xfe,0xff,0xff,0xfd,0xff,0xff,0xff,0xff			;keycode 0xc5, caps lock
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc6, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc7, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc8, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xc9, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xca, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xcb, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xcc, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xcd, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xce, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xcf, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd0, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd1, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd2, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd3, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd4, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd5, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd6, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd7, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd8, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xd9, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xda, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xdb, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xdc, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xdd, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xde, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xdf, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xe0, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xe1, no valid key
.db	0xfe,0xff,0xff,0xef,0xff,0xff,0xff,0xff		;keycode 0xe2, cursor left
.db	0xfe,0xff,0xff,0xff,0xfb,0xff,0xff,0xff		;keycode 0xe3, cursor right
.db	0xfe,0xff,0xff,0xff,0xf7,0xff,0xff,0xff		;keycode 0xe4, cursor up
.db	0xfe,0xff,0xff,0xff,0xef,0xff,0xff,0xff		;keycode 0xe5, cursor down
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xe6, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xe7, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xe8, no valid key
.db	0xfe,0xff,0xff,0xfe,0xff,0xff,0xff,0xff		;keycode 0xe9, DELETE ->delete line
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0xff		;keycode 0xea, ENTER
.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xfd		;keycode 0xeb, TAB
.db	0xfe,0xff,0xff,0xff,0xfe,0xff,0xff,0xff		;keycode 0xec, Backspace (CTRL + 0)
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xed, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xee, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xef, no valid key

.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf0, no valid key
.db	0xfe,0xff,0xff,0xfe,0xff,0xff,0xff,0xff		;keycode 0xf1, edit
.db	0xfe,0xff,0xff,0xff,0xfd,0xff,0xff,0xff		;keycode 0xf2, graphics
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf3, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf4, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf5, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf6, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf7, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf8, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xf9, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xfa, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xfb, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xfc, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xfd, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xfe, no valid key
.db	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff		;keycode 0xff, no valid key
