;################################################################################
;#										#
;# copyright (c) 2005-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################


show_space:	ldi	XL,0x20
show_char:	push	XH
		push	YL
		push	YH
		push	ZL
		push	ZH
		push	r0
		push	r1
		ldi	XH,8
		mul	XH,XL
		ldi	ZH,0x3c
		mov	ZL,r0
		add	ZH,r1
		lds	YL,vsys_cpos
		ldi	YH,1
show_char_1:	lpm	r0,Z+
		st	Y,r0
		inc	YH
		dec	XH
		brne	show_char_1
		inc	YL			;next cursor position
		sts	vsys_cpos,YL
		pop	r1
		pop	r0
		pop	ZH
		pop	ZL
		pop	YH
		pop	YL
		pop	XH
		ret

show_reg8:	rcall	show_char
		ldi	XL,':'
		rcall	show_char
		mov	XH,r16
		rcall	showhex
		rjmp	show_space

show_reg16:	rcall	show_char
		ldi	XL,':'
		rcall	show_char
		mov	XH,r17
		rcall	showhex
		mov	XH,r16
		rcall	showhex
		rjmp	show_space


show_break:	lds	XL,vsys_showkeys
		cpi	XL,0
		breq	show_break_e
		ldi	XL,0x80
		sts	vsys_cpos,XL
		ldi	XL,'P'
		movw	r16,PC_L
		rcall	show_reg16
		ldi	XL,'A'
		mov	r16,reg_a
		rcall	show_reg8
		ldi	XL,'H'
		movw	r16,reg_l
		rcall	show_reg16
		ldi	XL,'B'
		movw	r16,reg_c
		rcall	show_reg16
		ldi	XL,'D'
		movw	r16,reg_e
		rcall	show_reg16
show_break_e:	ret



showhex:
		mov	XL,XH
		swap	XL
		andi	XL,0x0f
		subi	XL,0xd0
		cpi	XL,0x3a
		brcs	showhex_1
		subi	XL,0xf9
showhex_1:	st	Y+,XL
		mov	XL,XH
		andi	XL,0x0f
		subi	XL,0xd0
		cpi	XL,0x3a
		brcs	showhex_2
		subi	XL,0xf9
showhex_2:	st	Y+,XL
		ret
