;################################################################################
;#										#
;# vsys - multi i/o for ATMega644						#
;# main library									#
;# copyright (c) 2005-2012 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

vint_frame:	ldi	XL,0xff
		mov	vline_l,XL		;line_l=0
		mov	vline_h,XL		;line_h=0
;decrement frame counter
		lds	XL,vsys_wait
		dec	XL
		sts	vsys_wait,XL

		in	XL,PINA			;get kj
		ldi	XH,0xbf
		sbrs	XL,6
		eor	XL,XH
		sts	vsys_kinput,XL

		ldi	XL,HIGH(emu_jitab)
		out	EEARL,XL
		sbi	GPIOR0,int_flag

		ldi	XH,0x00
		lds	XL,vsys_wait
		sbrc	XL,5
		ldi	XH,0x01
		sts	vsys_blink,XH
		ldi	XH,HIGH(attr_tab*2)
		sbrc	XL,5
		inc	XH
		sts	vsys_blinkt,XH

		lds	XH,vsys_kbdstate
		sbrs	XH,2			;skip if no left CTRL
		rjmp	vint_frame_1

vint_ppos:	lds	XL,vsys_keycode
		cpi	XL,0xf6			;F6 = reset and reload user
		breq	vint_frame_rel
		cpi	XL,0xf7			;F7 = reset and reload sys
		breq	vint_frame_rel

		cpi	XL,0xf5			;F5 = reset and reload default
		brne	vint_frame_x1
vint_frame_rel:	ldi	XL,HIGH(emu_jrtab)
		out	EEARL,XL
		rjmp	vint_frame_1

vint_frame_x1:	cpi	XL,0xfa			;save snapshot
		brne	vint_frame_xr
		ldi	XL,HIGH(emu_jrtab)
		out	EEARL,XL
		rjmp	vint_frame_1

vint_frame_xr:	cpi	XL,0xee
		brne	vint_frame_1
vint_frame_res:	cli				;disable further interrupts
		jmp	start

;--------------------------------------------------------------------------------
; vint handling for normal mode
;--------------------------------------------------------------------------------
vint_frame_1:	sbic	GPIOR0,noscreen_flag
		jmp	vsys_kir_end
		call	vsys_skeys_sp
		jmp	vsys_keyb

